#!/usr/bin/env python

import sys, os, getopt, re, math


class preprocess_affy:
	def __init__(self):
		pass



	def run(self):
		INFINITY = 10000
		entryi=tfnum #modify this and next line according to the output of activeTFDP.py
		entryj=4
		imf = open("./data/tdiff_GSE11003Gene2expUniqueNoheaderNomiss.txt",'r')
		lines =  imf.readlines()
		linenum = len(lines)
		rank2gene={}
		for i in range(1, linenum):
			line = lines[i].rstrip()
			stuff = line.split('\t')
			gene = stuff[0]
			rank = stuff[8]
			rank2gene[rank]=gene
		imf.close()
		#jscore=606
		
		#maxk=2
		maxk=1000

		cm=856
		cn=cm+1
		imf = open("./data/cutk_hyperPTFlist_GSE11003.txt",'r')#1       237     KRCTCNNNNMANAGC_UNKNOWN:0.0031847133758 
		lines =  imf.readlines()
		linenum = len(lines)
		cutk_sigTFs={}
		#for i in range(0, linenum):
		for i in range(cm-1, cn):
			line = lines[i].rstrip('\t')
			stuff = line.split('\t')
			k = int(stuff[0])
			count = int(stuff[1])
			cutk_sigTFs[k]=[]
			for j in range(2,count+2):
				tf = stuff[j].split(':')[0]
				cutk_sigTFs[k].append(tf)#cut=k, significant tfs
		imf.close()
	
		of3 = open("./data/c3tftDiffnum_GSE11003_DPBackTrack_thisksol.txt",'w')
		for cutk in range(cm,cn):
			imf = open("./data/c3tftDiffrank_GSE11003_cut1k",'r')#format RGAGGAARY_V$PU1_Q6      5100    13455  
			lines =  imf.readlines()
			linenum = len(lines)
			tfranks={}
			gcount={}
			ranktg={}
			for i in range(cutk+1):
				gcount[i]=0 #count repeat times of each genes in the cutting range cutk
			for i in range(0, linenum):
				line = lines[i].rstrip()
				stuff = line.split('\t')			
				tf = stuff[0]
				ranks = stuff[1:]
				tfranks[tf]=ranks
			tfmap={}
			#print len(cutk_sigTFs[cutk])
			c=0
			for i in range(len(cutk_sigTFs[cutk])):
				tf=cutk_sigTFs[cutk][i]	
			
				case=0
				if tf in tfranks.keys():
					#print tf
					#print tfranks[tf]
					for item in tfranks[tf]:

						k=int(item)

						if k in gcount.keys():
							gcount[k]=gcount[k]+1
							case=1
				if case==1:#this tf has tg within the cutoff
					tfmap[c]=tf #index tf with c
					ranktg[c]=tfranks[tf]#record tfc's ranks
					goodtg=[]
					for z in tfranks[tf]:
						zz = int(z)
						if zz in gcount.keys():
							#print zz
							goodtg.append(rank2gene[z])
							
					c=c+1
					#if len(goodtg)>0:
						#of3.write("tf=%s,ranks=%s\n" %(tf,'\t'.join(goodtg[0:])))
					
					
			
			imf.close()
			tfnum = len(tfmap)
			jscore=tfnum
		

			c={}
			b={}
			for i in range(0, tfnum+1):		
					c[i]=[]
					b[i]=[]
					for j in range(0,jscore+1):
						c[i].append(INFINITY)
						b[i].append(INFINITY)


			for j in range(0,jscore+1):	
				c[0][j]=0
				b[0][j]=0

			for i in range(1,tfnum+1):#
				c[i][0] = 0
				b[i][0] = 0
				tfi_name = tfmap[i-1]
				for j in range(1, jscore + 1):
					vi = 0
					tfi_ranks_1k=ranktg[i-1] #store the tfi's target genes rank

					for r in tfi_ranks_1k:
						rr = int(r)
						if rr in gcount.keys():
							gain = 1.0/gcount[rr]
							vi = vi+gain
								
					if c[i-1][j -1]+vi > c[i - 1][j]:
						c[i][j]= c[i-1][j-1]+vi
						b[i][j]=1

					else:
						c[i][j]= c[i-1][j]
						b[i][j]=0
		
			sol=[]
			m=entryi
			n=entryj
			while (m>0 and n>0):
				bt = b[m][n] # backtrack matrix if entry is 0,meaning not use tf(i-1),
				if bt==1:# using tf(i-1), find out whether overlapping num tgs
					thistfname=tfmap[m-1]
					sol.append(thistfname)
					m=m-1
					n=n-1
				else:
					m=m-1
		
			of3.write("track from entry %d,%d,and sol is %s\n" % (entryi,entryj,'\t'.join(sol[0:])))
		
		of3.close()
	

if __name__ == '__main__':

	instance = preprocess_affy()
       	instance.run()

